(***************************************************

Ant Movie Catalog importation script
www.antp.be/software/moviecatalog/

[Infos]
Authors=
Title=SoulSnakeUtils.pas
Description=
Site=
Language=?
Version=
Requires=3.5.1
Comments=
License=
GetInfo=0

[Options]

***************************************************)

unit SoulSnakeUtils;

const SoulSnakeUtils_Version = 1;

{
  History
  -------
  v.1:  Added FormatFilename, GenerateFilename,
        GenerateFilenameWithGetOptions functions.
}

{
  Format filename for windows and linux.
}
function FormatFilename(title : string) : string;
begin
  result := title;
  result := StringReplace(result, '?', '');
  result := StringReplace(result, ':', '-');
  result := StringReplace(result, '<', '');
  result := StringReplace(result, '>', '');
  result := StringReplace(result, '"', '');
  result := StringReplace(result, '*', '');
  result := StringReplace(result, '|', '-');
  result := StringReplace(result, '/', '-');
  result := StringReplace(result, '\', '-');
  result := StringReplace(result, '  ', ' ');
  result := StringReplace(result, '( ', '(');
  result := StringReplace(result, ' )', ')');
  result := Trim(result);
end;

{
  Generate filename according to the following local options :
  optNumber|1=Oui|0=Non
  optTitle|0=Titre Traduit [Titre Original]|1=Titre Traduit|2=Titre Original
  optYear|1=Oui|0=Non
  optLanguages|1=Oui|0=Non
  optSubtitles|1=Oui|0=Non
  optCategories|1=Oui|0=Non
  optSource|1=Oui|0=Non
  optVideoFormat|1=Oui|0=Non
  optAudioFormat|1=Oui|0=Non
  optFrameRate|1=Oui|0=Non
}
function GenerateFilename(optNumber : Integer;
optTitle : Integer;
optYear : Integer;
optLanguages : Integer;
optSubtitles : Integer;
optCategories : Integer;
optSource : Integer;
optVideoFormat : Integer;
optAudioFormat : Integer;
 optFrameRate : Integer) : string;
var
  filename, tmp, tmp2 : string;
  i, maxsize : Integer;

begin
  maxsize := 220;
  filename := '';

  if (GetField(fieldOriginalTitle) <> '') or (GetField(fieldTranslatedTitle) <> '') then
  begin
    filename := '$$$$';

    if (optNumber = 1) then
    begin
      i := StrToInt(GetField(fieldNumber), 0);
      tmp := '';
      if (i < 10) then
        tmp := tmp + '0';
      if (i < 100) then
        tmp := tmp + '0';
      if (i < 1000) then
        tmp := tmp + '0';
      filename := StringReplace(filename, '$$$$', '[' + tmp + IntToStr(i) + '] $$$$');
    end;
    
    if (GetField(fieldTranslatedTitle) <> '') and ((GetField(fieldOriginalTitle) = '') or (optTitle = 0) or (optTitle = 1)) then
      filename := StringReplace(filename, '$$$$', GetField(fieldTranslatedTitle) + '$$$$');

    if (GetField(fieldOriginalTitle) <> '') and ((GetField(fieldTranslatedTitle) = '') or (optTitle = 2)) then
      filename := StringReplace(filename, '$$$$', GetField(fieldOriginalTitle) + '$$$$');

    if (length(filename) < maxsize) and (optYear = 1) and (GetField(fieldYear) <> '') then
    begin
      tmp := filename + ' ' + GetField(fieldYear);
      if (length(tmp) < maxsize) then
        filename := tmp;
    end;

    if (length(filename) < maxsize) and (optLanguages = 1) and (GetField(fieldLanguages) <> '') then
    begin
      tmp2 := GetField(fieldLanguages);
      tmp2 := StringReplace(tmp2, 'FR (VFF)', 'VFF');
      tmp2 := StringReplace(tmp2, 'FR (VFQ)', 'VFQ');
      tmp2 := StringReplace(tmp2, ', ', ',');
      tmp2 := StringReplace(tmp2, ' ,', ',');
      tmp2 := StringReplace(tmp2, ',', ' ');
      tmp := filename + ' ' + tmp2;
      if (length(tmp) < maxsize) then
        filename := tmp;
    end;
    
    if (length(filename) < maxsize) and (optAudioFormat = 1) and (GetField(fieldAudioFormat) <> '') then
    begin
      tmp2 := GetField(fieldAudioFormat);
      // tmp2 := StringReplace(tmp2, 'MPEG-1/2 L3', 'MP3');
      // tmp2 := StringReplace(tmp2, 'MPEG-1 Audio layer 3', 'MP3');
      // tmp2 := StringReplace(tmp2, 'WMA2', 'WMA');
      tmp2 := StringReplace(tmp2, ', ', ' ');
      tmp := filename + ' ' + tmp2;
      if (length(tmp) < maxsize) then
        filename := tmp;
    end;
    
    if (length(filename) < maxsize) and (optVideoFormat = 1) and (GetField(fieldVideoFormat) <> '') then
    begin
      tmp2 := GetField(fieldVideoFormat);
      tmp2 := StringReplace(tmp2, 'DivX ', 'DivX');
      tmp2 := StringReplace(tmp2, ', ', ',');
      tmp2 := StringReplace(tmp2, ' ,', ',');
      tmp2 := StringReplace(tmp2, ',', ' ');
      tmp := filename + ' ' + tmp2;
      if (length(tmp) < maxsize) then
        filename := tmp;
    end;
    
    if (length(filename) < maxsize) and (optFrameRate = 1) and (GetField(fieldFrameRate) <> '') then
    begin
      tmp2 := GetField(fieldFrameRate);
      tmp2 := StringReplace(tmp2, '.000', '');
      tmp2 := tmp2 + 'ims';
      tmp := filename + ' ' + tmp2;
      if (length(tmp) < maxsize) then
        filename := tmp;
    end;

    if (length(filename) < maxsize) and (optSubtitles = 1) and (GetField(fieldSubtitles) <> '') then
    begin
      tmp2 := GetField(fieldSubtitles);
      tmp2 := StringReplace(tmp2, ', ', ',');
      tmp2 := StringReplace(tmp2, ' ,', ',');
      tmp2 := StringReplace(tmp2, ',', ' ST');
      tmp := filename + ' ST' + tmp2;
      if (length(tmp) < maxsize) then
        filename := tmp;
    end;

    if (length(filename) < maxsize) and (optSource = 1) and (GetField(fieldSource) <> '') then
    begin
      tmp2 := GetField(fieldSource);
      tmp2 := StringReplace(tmp2, ', ', ',');
      tmp2 := StringReplace(tmp2, ' ,', ',');
      tmp2 := StringReplace(tmp2, ',', ' ');
      tmp2 := StringReplace(tmp2, ' Version Originale', '');
      if (GetField(fieldMediaType) <> StringReplace(GetField(fieldMediaType), 'RIP', '')) then
      begin
        tmp2 := StringReplace(tmp2, 'DVD', 'DVDRip');
        tmp2 := StringReplace(tmp2, 'BD', 'BDRip');
        tmp2 := StringReplace(tmp2, 'HDDVD', 'HDDVDRip');
      end;
      tmp := filename + ' ' + tmp2;
      if (length(tmp) < maxsize) then
        filename := tmp;
    end;
    
    if (length(filename) < maxsize) and (optCategories = 1) and (GetField(fieldCategory) <> '') then
    begin
      tmp2 := GetField(fieldCategory);
      tmp2 := StringReplace(tmp2, ', ', ',');
      tmp2 := StringReplace(tmp2, ' ,', ',');
      tmp2 := StringReplace(tmp2, ',', ' ');
      //tmp2 := StringReplace(tmp2, 'Science fiction', 'Science-fiction');
      //tmp2 := StringReplace(tmp2, 'Comdie dramatique', 'Comdie-dramatique');
      if (optSource = 1) then
      begin
        tmp2 := StringReplace(tmp2, 'Animation', '');
        tmp2 := StringReplace(tmp2, '  ', ' ');
        tmp2 := StringReplace(tmp2, 'Walt Disney', '');
        tmp2 := StringReplace(tmp2, '  ', ' ');
        tmp2 := StringReplace(tmp2, 'Manga', '');
        tmp2 := StringReplace(tmp2, '  ', ' ');
        tmp2 := StringReplace(tmp2, 'Humour', '');
        tmp2 := StringReplace(tmp2, '  ', ' ');
        tmp2 := StringReplace(tmp2, 'Concert', '');
        tmp2 := StringReplace(tmp2, '  ', ' ');
        tmp2 := StringReplace(tmp2, 'Thtre', '');
        tmp2 := StringReplace(tmp2, '  ', ' ');
        tmp2 := StringReplace(tmp2, 'Comdie musicale', '');
        tmp2 := StringReplace(tmp2, '  ', ' ');
        tmp2 := StringReplace(tmp2, 'Srie TV', '');
        tmp2 := StringReplace(tmp2, '  ', ' ');
        tmp2 := StringReplace(tmp2, 'Srie', '');
        tmp2 := StringReplace(tmp2, '  ', ' ');
        tmp2 := StringReplace(tmp2, 'Documentaire', '');
        tmp2 := StringReplace(tmp2, '  ', ' ');
        tmp2 := Trim(tmp2);
      end;
      tmp := filename + ' ' + tmp2;
      if (length(tmp) < maxsize) then
        filename := tmp;
    end;

    if (length(filename) < maxsize) and (optTitle = 0) and (GetField(fieldOriginalTitle) <> '') and (GetField(fieldTranslatedTitle) <> '') and (GetField(fieldOriginalTitle) <> GetField(fieldTranslatedTitle)) then
    begin
      tmp := StringReplace(filename, '$$$$', ' [' + GetField(fieldOriginalTitle) + ']$$$$');
      if (length(tmp) < maxsize) then
        filename := tmp;
    end;

    filename := StringReplace(filename, '$$$$', '');
    filename := FormatFilename(filename);

    if (length(filename) > maxsize - 4) then
    begin
      filename := copy(filename, 0, maxsize - 4);
      filename := Trim(filename);
    end;
  end;
  result := filename;
end;

{
  Generate filename according to the following general options :
Numero=1|1|1=Oui|0=Non
Titre=0|0|0=Titre Traduit [Titre Original]|1=Titre Traduit|2=Titre Original
Date=1|1|1=Oui|0=Non
Langues=1|1|1=Oui|0=Non
Soustitres=1|1|1=Oui|0=Non
Genres=1|0|1=Oui|0=Non
Origine=1|0|1=Oui|0=Non
FormatVideo=1|0|1=Oui|0=Non
FormatAudio=1|0|1=Oui|0=Non
Frequence=1|0|1=Oui|0=Non
}
function GenerateFilenameWithGetOptions() : string;
begin
  result := GenerateFilename(GetOption('Numero'), GetOption('Titre'), GetOption('Date'),
            GetOption('Langues'), GetOption('Soustitres'), GetOption('Genres'),
			GetOption('Origine'), GetOption('FormatVideo'), GetOption('FormatAudio'), GetOption('Frequence'));
end;

// *****
begin
end.
