/*-----------------------------------------------------------*\
| Interactive movie template created by Ronald van den Berg   |
| Made for Ant Movie Cataglog http://www.antp.be/software     |
| Based on the template made by Twink beta version 0.8        |
| Free for private and non-commercial usage                   |
| Last update on 8 March 2011 - Version 3.0.4 STABLE VERSION  |
| Copyright  2011 Bergware International -- The Netherlands  |
\*-----------------------------------------------------------*/

//SYSTEM FILES
var database='movies.xml'; //Movie database
var layouts='layout*.xml'; //Layout files
var locale='locale.xml';   //Local translations

//SYSTEM CHANGEABLES
var buttons=['++','--'];   //Expand & Collapse buttons
var bracket='[]';          //Surrounding brackets
var expiry=365;            //Cookie validity in days
var dateYMD='dateYMD';     //Attribute to hold YMD date

//MOBILE PHONE IDs
var phones=['android','blackberry','iphone','palm','symbian','windows ce'];

//HTML CODES
var br='<br/>';
var hr='<hr/>';
var sp='&nbsp;';

//SYSTEM CONSTANTS
var letters='ABCDEFGHIJKLMNOPQRSTUVWXYZ';
var mailto='mailto:';
var scheme='play:';
var pcid='pc:';

//SYSTEM VARIABLES
var movies;           //Array containing all titles
var movie;            //Individual title
var categories;       //Array of selectable categories
var genres;           //List of genres per category
var startfrom;        //Starting entry in list
var sortfield;        //Field to sort on
var layout;           //Current layout in use
var column;           //Column used for sorting
var columns;          //Total number of columns in table
var rowindex;         //Index number in selected category
var xmlData;          //XML source file: database
var xmlLayout;        //XML source file: layout
var xmlLocale;        //XML source file: local translations
var emptyTable;       //Flag: no titles found
var expanded;         //Flag: show/hide extra info
var totals;           //Flag: include/exclude totals in email
var save;             //Flag: save/forget favorites list
var my;               //Array holding default settings
var view3D;           //3D view ON or OFF
var oPopup;           //New email/RC window
var onTop;            //Keep tooltip on top
var home;             //Home network identifier
var banner;           //Holds initial banner height
var devices;          //Holds user players list

var category;         //Option in layout.xml, default value=all
var pagesize;         //Option in layout.xml, default value=10
var sortkey;          //Option in layout.xml, default value=none
var sortdir;          //Option in layout.xml, default value=A-Z
var searchkey;        //Option in layout.xml, default value=description
var separator;        //Option in layout.xml, default value=false
var player;           //Option in layout.xml, default value=PC

//GENERAL PROTOTYPES
String.prototype.trim=function(){
 return this.replace(/(^\s+)|(\s+$)/g,'');
};

String.prototype.equalTo=function(s){
 return this.toLowerCase()===s.toLowerCase();
};

String.prototype.toCapital=function(){
 return isNaN(this)?this.charAt(0).toUpperCase()+this.substr(1):'#';
};

String.prototype.mReplace=function(hash){
 var exp=[];
 for (var key in hash) exp.push(key);
 return this.replace(new RegExp(exp.join('|'),'g'),function(m){return hash[m]||hash['\\'+m];});
};

String.prototype.linefeed=function(){
 return this.replace(/(\|)|({PLAYER})/g,function(m,a1){return a1?br:player});
};

String.prototype.encode=function(){
 return this.replace(/(\|)|(')|(")|({PLAYER})/g,function(m,a1,a2,a3){return a1?'&#13;&#10;':a2?'&#39;':a3?'&#34;':player});
};

String.prototype.spaceOut=function(){
 return this.replace(/ /g,'');
};

String.prototype.spaceIn=function(){
 return this.replace(//g,' ');
};

String.prototype.set=function(s){
 return 'S'+this.toString()+(s>0?letters.charAt(s-1):'');
};

String.prototype.divide=function(){
 return this.split(/ ?[/|,] ?/);
};

String.prototype.joinTitle=function(){
 var title=[];
 for (var i=0,id;id=this.split(',')[i];i++){
  for (var j=0,tag;tag=xmlLocale.getElementsByTagName('class')[j];j++){
   if (id==tag.getAttribute('id')){
    title.push(tag.getAttribute('title'));
    break;
   }
  }
 }
 return title.join(', ');
};

String.prototype.network=function(net){
 return net?this.substr(0,this.lastIndexOf('.'))===net.substr(0,net.lastIndexOf('.')):true;
};

String.prototype.ext=function(ext){
 return this.substr(this.lastIndexOf('.')+1)===ext;
};

String.prototype.addSlash=function(){
 return this.search(/[\/]$/)>=0?this:this+'/';
};

String.prototype.isDune=function(){
 return this.search(/^dune/i)>=0;
};

Number.prototype.grouped=function(){
 return this.toLocaleString().replace(/[.,]00$/,'');
};

//ARROW PROTOTYPES
String.prototype.arrowOn=function(){
 return this.replace(/(<\/div>$)/i,'<img src="'+my['images']+my['arrow'].replace('*',sortdir?'up':'down')+'">'+'$1');
};

String.prototype.arrowOff=function(){
 return this.replace(/<img[^>]+>/i,'');
};

String.prototype.arrowSwap=function(){
 return sortdir?this.replace('down','up'):this.replace('up','down');
};

String.prototype.arrowRL=function(dirRL){
 return dirRL?this.replace('right','left'):this.replace('left','right');
};

//GENERAL FUNCTIONS
function fix(s){
 return s?isNaN(+s)?s.toLowerCase():+s:'';
}

function lowerCase(s){
 return s?s.toLowerCase():'';
}

function page(x){
 var p=x/pagesize;
 return Math.floor(p+((p-Math.floor(p))==0?0:1));
}

function totalPages(){
 return pagesize>0?page(movies[category].length)||1:1;
}

function currentPage(){
 return pagesize>0?page(movies[category].length)-page(movies[category].length-startfrom-pagesize):1;
}

function toggle(x,y){
 document.getElementById(x).style.display=(y==-1 && document.getElementById(x).style.display=='' || y==0?'none':'');
}

function invisible(x){
 return document.getElementById(x).style.display!='';
}

function map(win,cell,body){
 var size=win?win:0;
 if (cell && (!size||(size>cell))) size=cell;
 return body && (!size||(size>body))?body:size;
}

function getWindowWidth(){
 return map(window.innerWidth?window.innerWidth:0,document.documentElement?document.documentElement.clientWidth:0,document.body?document.body.clientWidth:0);
}

function getWindowHeight() {
 return map(window.innerHeight?window.innerHeight:0,document.documentElement?document.documentElement.clientHeight:0,document.body?document.body.clientHeight:0);
}

function cursorWait(){
 document.body.style.cursor='wait';
}

function cursorClear(){
 document.body.style.cursor='default';
}

function xlate(tag){
 for (var n=0,text;text=xmlLocale.getElementsByTagName('field')[0].attributes[n];n++){
  if (tag==text.name) return text.value;
 }
 return tag;
}

function mobilePhone(){
 var device=navigator.userAgent.toLowerCase();
 for (var i=0,phone;phone=phones[i];i++){
  if (device.indexOf(phone)>=0) return true;
 }
 return false;
}

//HELPER FUNCTIONS
function rate(number){
 return my['images']+my['rating'].replace('*',Math.round(eval(number))||0);
}

function flag(id,folder){
 for (var i=0,code;code=xmlLocale.getElementsByTagName('flag')[i];i++){
  for (var j=0,node;node=code.childNodes[j];j++){
   if (id.equalTo(node.firstChild.data)) return my['images']+(folder||my['flag']).replace('*',code.getAttribute('file'));
  }
 }
 return null;
}

function audio(id){
 for (var i=0,code;code=xmlLocale.getElementsByTagName('audio')[i];i++){
  for (var j=0,node;node=code.childNodes[j];j++){
   if (id.equalTo(node.firstChild.data)) return my['images']+my['audio'].replace('*',code.getAttribute('file'));
  }
 }
 return null;
}

function video(id){
 for (var i=0,code;code=xmlLocale.getElementsByTagName('video')[i];i++){
  for (var j=0,node;node=code.childNodes[j];j++){
   if (id.equalTo(node.firstChild.data)) return my['images']+my['video'].replace('*',code.getAttribute('file'));
  }
 }
 return null;
}

function mpaa(id){
 for (var i=0,tag;tag=xmlLocale.getElementsByTagName('class')[i];i++){
  if (id.equalTo(tag.getAttribute('id'))) return my['images']+my['mpaa'].replace('*',tag.getAttribute('file'));
 }
 return null;
}

function region(number){
 return number.search(/[0-6ABC]/)>=0?my['images']+my['region'].replace('*',number):null;
}

function format(time,f){
 if (!time) return '';
 switch (f){
 case 'h':
  var h=Math.floor(time/60);
  var m=time-h*60;
  return h+':'+(m<10?'0':'')+m+' '+hour;
 case 'm':
  return time+' '+min;
 case 's':
  return time*60+' '+sec;
 default:
  return time;
 }
}

function path(img){
 return img?datapath+img:my['images']+my['empty'];
}

function append(){
 var text=[];
 for (var i=0,l=arguments.length;i<l;i++){
  if (arguments[i]) {text.push(arguments[i]);} else {return '';}
 }
 return text.join('');
}

function merge(){
 var text=[arguments[0]];
 for (var i=1,l=arguments.length;i<l;i++){
  if (arguments[i]) {text.push(arguments[i]);} else {return text[0];}
 }
 return text.join('');
}

function site(url){
 return url?url.replace(/([a-z])\/.*/i,'$1'):'';
}

function play(url){
 return url?(url.substr(0,scheme.length)!=scheme?scheme:'')+url:'';
}

function list(entry,number){
 if (!entry) return '';
 var token=entry.match(/ ?[|,] ?/);
 return number?entry.split(token,number).join(token):entry;
}

//COOKIE FUNCTIONS
function createCookie(name,value,days){
 var date=new Date();
 date.setTime(date.getTime()+(days*24*3600*1000));
 var expires='; expires='+(days?date.toUTCString():'0');
 document.cookie=name+'='+value+expires+'; path=/';
}

function readCookie(name){
 var value=name+'=';
 for (var i=0,c;c=document.cookie.split(';')[i];i++){
  while (c.charAt(0)==' ') c=c.substring(1,c.length);
  if (c.indexOf(value)==0) return c.substring(value.length,c.length);
 }
 return null;
}

function eraseCookie(name){
 createCookie(name,'',0);
}

function cookie(item){
 return 'pref.layout'+(item?layout.substr(6,2)+item:'');
}

function clearCookies(){
 for (var i=0,c;c=document.cookie.split(';')[i];i++) eraseCookie(c.split('=')[0]);
}

//STYLESHEET FUNCTIONS
function setActiveStyleSheet(style,first){
 for (var i=0,a;a=document.getElementsByTagName('link')[i];i++){
  if (a.getAttribute('rel').indexOf('style')>=0 && a.getAttribute('title')){
   a.disabled=true;
   if (a.getAttribute('title')==style){
    a.disabled=false;
    if (!first) createCookie('layout.style',style,expiry);
   }
  }
 }
}

function getActiveStyleSheet(){
 for (var i=0,a;a=document.getElementsByTagName('link')[i];i++){
  if (a.getAttribute('rel').indexOf('style')>=0 && a.getAttribute('title') && !a.disabled)
   return a.getAttribute('title');
 }
 return null;
}

function getPreferredStyleSheet(){
 for (var i=0,a;a=document.getElementsByTagName('link')[i];i++){
  if (a.getAttribute('rel').indexOf('style')>=0 && a.getAttribute('rel').indexOf('alt')==-1 && a.getAttribute('title'))
   return a.getAttribute('title');
 }
 return null;
}

function setMobileStyleSheet(){
 var links=document.getElementsByTagName('link');
 if (links[links.length-1].getAttribute('title')!=null){
  var link=document.createElement('link');
  link.setAttribute('rel','stylesheet');
  link.setAttribute('type','text/css');
  link.setAttribute('href','themes/mobile.css');
  document.getElementsByTagName('head')[0].appendChild(link);
 }
}

//EVENTS HANDLING
function getEventSource(e){
 e=e||window.event;
 e.cancelBubble=true;
 if (e.stopPropagation) e.stopPropagation();
 e=e.srcElement||e.target;
 while (e.nodeName!='TD'){
  e=e.parentNode;
 }
 return e;
}

function hoverOn(e){
 e=getEventSource(e).parentNode;
 for (var i=0,cell;cell=e.cells[i];i++){
  cell.className='bodyhover';
 }
}

function hoverOff(e){
 e=getEventSource(e).parentNode;
 for (var i=0,cell;cell=e.cells[i];i++){
  cell.className='bodycontent';
 }
}

function mouseX(e){
 if (e.pageX){
  return e.pageX;
 }else if (e.clientX){
  return e.clientX;
 }
 return 0;
}

function mouseY(e){
 if (e.pageY){
  return e.pageY;
 }else if (e.clientY){
  return e.clientY;
 }
 return 0;
}

function addEvent(element,event,procedure,cursor){
 if (document.all){
  element.detachEvent('on'+event,procedure);
  element.attachEvent('on'+event,procedure);
  if (!cursor) element.style.cursor='hand';
 }else if (document.addEventListener){
  element.removeEventListener(event,procedure,false);
  element.addEventListener(event,procedure,false);
  if (!cursor) element.style.cursor='pointer';
 }
}

//STRUCTURES
function groupSet(name,setting,checked,image){
 this.name=name;
 this.setting=setting;
 this.checked=checked;
 this.filled=checked;
 this.empty=false;
 this.image=image;
}

//INITIALISATION FUNCTIONS 
function loadXML(dynamic){
 if (!window.ActiveXObject && !window.XMLHttpRequest){
  alert("Your browser can't handle this script");
  return;
 }
 cursorWait();
 if (datapath) datapath=datapath.addSlash();
 if (!dynamic){
  xmlData=loadFile(datapath+database);
  xmlLocale=loadFile(locale);
 }
 layout=readCookie(cookie())||dynamic||defaultLayout+'.xml';
 xmlLayout=loadFile(layout);
 setTimeout('init()',0);
}

function loadFile(source){
 if (window.ActiveXObject){
  var xmlfile=new ActiveXObject('Microsoft.XMLDOM');
  xmlfile.async=false;
  xmlfile.load(source);
  return xmlfile;
 }else if (window.XMLHttpRequest){
  var xmlfile=new window.XMLHttpRequest();
  xmlfile.open('GET',source,false);
  xmlfile.send(null);
  return xmlfile.responseXML;
 }else{
  return null;
 }
}

function init(){
 var oRow=document.getElementById('oHeaders').insertRow(0);
 var nRow=xmlLayout.getElementsByTagName('row')[0];
 var nOptions=xmlLayout.getElementsByTagName('options')[0];
 var html='<div class="boxcontent" style="font-weight:bold;">';
 var cso=sp+'</div>';
 readDefaults();
 setActiveStyleSheet(readCookie('layout.style')||getPreferredStyleSheet(),true);
 if (mobilePhone()) setMobileStyleSheet();
 category=nOptions.getAttribute('category')||all;
 if (category.equalTo('all')) category=all;
 pagesize=+readCookie(cookie('pagesize'))||eval(nOptions.getAttribute('pagesize'))||10;
 sortkey=readCookie(cookie('sortkey'))||nOptions.getAttribute('sortkey')||'';
 sortdir=readCookie(cookie('sortdir'))?eval(readCookie(cookie('sortdir'))):nOptions.getAttribute('sortdir')=='Z-A'||false;
 searchkey=nOptions.getAttribute('searchkey')||'Description';
 separator=eval(nOptions.getAttribute('separator'))||false;
 player=readCookie('player')||nOptions.getAttribute('player')||'PC';
 view3D=eval(readCookie('layout.view3D'))||false;
 columns=0;
 expanded=false;
 for (var i=0,device;device=xmlLocale.getElementsByTagName('player')[i];i++){
  var model=device.attributes[0].value;
  devices[model]=[];
  for (var n=1,att;att=device.attributes[n];n++) devices[model][att.name]=att.value;
 }
 for (var i=0,nCell;nCell=nRow.getElementsByTagName('cell')[i];i++){
  var oCell=oRow.insertCell(-1);
  oCell.className='bodycontent';
  var title=nCell.getAttribute('title')||'';
  var sortlist=nCell.getAttribute('sortlist');
  if (!sortlist){
   oCell.innerHTML=html+sp+title+cso;
  }else{
   var width=(nCell.getAttribute('width')||200);
   var attribs=' class="boxcontent" style="width:'+width+'px"';
   var dropdown='<select id="oSortList"'+attribs+' onchange=javascript:sortList();></select>';
   oCell.innerHTML=(title?html:'')+dropdown+(title?sp+sp+sp+sp+sp+sp+sp+sp+title+cso:'');
   if (sortlist.equalTo('all')){
    var tags=[];
    for (var n=0,tag;tag=xmlData.getElementsByTagName('Movie')[0].attributes[n];n++) tags.push(tag.name);
   }else{
    var tags=sortlist.split(',');
   }
   var list=document.getElementById('oSortList').options;
   for (var n=0,tag;tag=tags[n];n++) list[list.length]=new Option(xlate(tag),tag,tag==sortkey,tag==sortkey);
  }
  oCell.colSpan=+nCell.getAttribute('colspan')||1;
  oCell.align=nCell.getAttribute('align')||'left';
  columns+=oCell.colSpan;
  var sortby=nCell.getAttribute('sortby');
  if (sortby){
   oCell.sort=sortby;
   if (sortby==sortkey){
    oCell.innerHTML=oCell.innerHTML.arrowOn();
    column=oCell;
   }
   addEvent(oCell,'click',sortMovies);
  }
 }
 oRow=document.getElementById('oCategories').insertRow(0);
 oCell=oRow.insertCell(0);
 oCell.colSpan=columns;
 oCell.className='bodycontent';
 oCell.innerHTML='<div class="boxcontent" id="oGroupName"></div>';
 if (eval(my['more'])){
  oCell=document.getElementById('oPagesCount');
  addEvent(oCell,'mouseover',moreInfo);
  addEvent(oCell,'mouseout',moreInfo);
 }
 makeCategories();
 html=document.getElementById('oField').options;
 html.length=0;
 html[0]=new Option(xlate('AllFields'),'all');
 for (var n=0,tag;tag=searchkey.split(',')[n];n++) html[html.length]=new Option(xlate(tag),tag);
 headerText();
 footerBtn();
 clearTable();
 toggle('wait',0);
 toggle('oMovieHeader',1);
 toggle('oMovieContent',1);
 showMovies();
 if (!invisible('oSetup')) showSetup(true);
 setTimeout('sizeTable()',0);
 cursorClear();
}

//CREATION FUNCTIONS
function readDefaults(){
 oPopup=new Object;
 oPopup.closed=true;
 devices=[];
 movies=[];
 genres=[];
 my=[];
 if (!banner) banner=document.getElementById('banner').offsetHeight;
 for (var n=0,tag;tag=xmlLocale.getElementsByTagName('locale')[0].attributes[n];n++) window[tag.name]=tag.value;
 all=all.spaceOut();
 favorites=favorites.spaceOut();
 action=action||mailto;
 save=null;
 totals=null;
 find=find.spaceOut();
 formats=formats.split(',');
 caption=caption.split(',');
 summary=summary.split(',');
 warning=warning.split('|');
 switch (system){
 case 'dmy': ymd=function(s){return s?(s.slice(6)+s.slice(3,5)+s.slice(0,2))*1:0;}; break;
 case 'mdy': ymd=function(s){return s?(s.slice(6)+s.slice(0,2)+s.slice(3,5))*1:0;}; break;
 case 'ymd': ymd=function(s){return s?(s.slice(0,4)+s.slice(5,7)+s.slice(8))*1:0;}; break;
 default   : ymd=function(s){return s?s:0;};}
 for (var i=0,att;att=xmlLayout.getElementsByTagName('default')[0].attributes[i];i++) my[att.name]=att.value;
 my['flag2']=my['flag2']||my['flag'];
 cvi_reflex.defaultTilt='left';
 cvi_reflex.defaultHeight=25;
 cvi_reflex.defaultBorder=1;
 cvi_reflex.defaultColor='#969696';
 cvi_strip.defaultNoshadow=true;
 cvi_strip.defaultStrip=85;
}

function headerText(){
 var menu=xmlLocale.getElementsByTagName('menu')[0];
 var email=menu.getAttribute('emailLabel');
 var setup=menu.getAttribute('setupLabel');
 var info=menu.getAttribute('infoLabel');
 var about=menu.getAttribute('aboutLabel');
 var remote=menu.getAttribute('rcLabel');
 var findText=menu.getAttribute('findText');
 document.getElementById('oSearch').innerHTML=document.getElementById('oSearch').innerHTML.mReplace({'{SEARCH}':find+'...','{SEARCH_TEXT}':findText});
 document.getElementById('oHeaderText').innerHTML=document.getElementById('oHeaderText').innerHTML.mReplace({'{EMAIL}':email,'{SETUP}':setup,'{INFO}':info,'{RC}':remote,'{ABOUT}':about});
}

function setLayout(format){
 if (format==layout) return;
 toggle('oMovieHeader',0);
 toggle('oMovieContent',0);
 toggle('wait',1);
 document.getElementById('oHeaders').deleteRow(0);
 document.getElementById('oCategories').deleteRow(0);
 if (format){
  createCookie(cookie(),format,expiry);
 }else{
  clearCookies();
  toggle('oInfo',0);
  toggle('oAbout',0);
  showSetup();
 }
 setTimeout('loadXML("'+format+'")',0);
}

function makeCategories(){
 categories=[];
 for (var n=0,nGroup;nGroup=xmlLayout.getElementsByTagName('group')[n];n++){
  var name=nGroup.getAttribute('name');
  var setting=nGroup.getAttribute('setting');
  var checked=eval((readCookie(name)||nGroup.getAttribute('checked')));
  var image=eval(nGroup.getAttribute('flag'));
  categories[n]=new groupSet(name,setting,checked,image);
 }
 var films=[];
 genres[0]=[];
 movies[all]=films;
 movies[favorites]=[];
 for (var x=0,group;group=categories[x];x++){
  genres[0][x]=(group.name+caption[9]).trim().toCapital().spaceOut();
  genres[x+1]=[];
 }
 for (var i=0,element;element=xmlData.getElementsByTagName('Movie')[i];i++){
  for (x=0;group=categories[x];x++){
   if (!group.checked) continue;
   try{
    var text=eval('element.'+group.setting);
   }catch(err){
    var text=null;
   }
   var labels=text?text.divide():[group.name+caption[9]];
   for (var j=0,label;label=labels[j];j++){
    label=label.trim().toCapital().spaceOut();
    if (label!=''){
     var buffer=movies[label];
     if (buffer){
      buffer.push(element);
     }else{
      buffer=[];
      movies[label]=buffer;
      buffer[0]=element;
      if (text){
       var fill=genres[x+1];
       fill.push(label);
      }else{
       group.empty=true;
      }
     }
    }
   }
  }
  element.setAttribute(dateYMD,ymd(element.getAttribute('Date')));
  films.push(element);
  var value=readCookie(element.getAttribute('Number'));
  if (value){
   element.setAttribute('Bookmark',value);
   movies[favorites].push(element);
  }
 }
 for (var n=1,list;list=genres[n];n++) list.sort(alphabetic);
 showCategories();
}

function addCategory(x){
 var group=categories[x];
 group.checked=!group.checked;
 createCookie(group.name,group.checked,expiry);
 if (!group.filled){
  group.filled=true;
  for (var i=0,element;element=xmlData.getElementsByTagName('Movie')[i];i++){
   try{
    var text=eval('element.'+group.setting);
   }catch(err){
    var text=null;
   }
   var labels=text?text.divide():[group.name+caption[9]];
   for (var j=0,label;label=labels[j];j++){
    label=label.trim().toCapital().spaceOut();
    if (label!=''){
     var buffer=movies[label];
     if (buffer){
      buffer.push(element);
     }else{
      buffer=[];
      movies[label]=buffer;
      buffer[0]=element;
      if (text){
       var fill=genres[x+1];
       fill.push(label);
      }else{
       group.empty=true;
      }
     }
    }
   }
  }
  genres[x+1].sort(alphabetic);
 }
 showCategories();
 sizeTable();
}

//DISPLAY FUNCTIONS
function sizeTable(){
 if (mobilePhone()) return;
 var resize=document.getElementById('oMovieHeader').offsetHeight+(invisible('oSetup')?banner:document.getElementById('oMenu').offsetHeight)+'px';
 document.getElementById('movies').style.top=resize;
 document.getElementById('header').style.height=resize;
}

function createLabel(name,enclosed){
 var b0=enclosed?bracket.charAt(0):'';
 var b1=enclosed?bracket.charAt(1):'';
 return '<a href=javascript:showMovies("'+name+'");>'+b0+name.spaceIn()+b1+'</a> ';
}

function createFlag(name){
 var ns=name.spaceIn();
 return '<a href=javascript:showMovies("'+name+'");><img src="'+flag(ns)+'" title="'+ns+'" style="margin-top:4px;"></a> ';
}

function showCategories(){
 var nl=false;
 var html=[createLabel(all,true),createLabel(favorites,true)];
 for (var c=0,label;label=genres[0][c];c++){
  var group=categories[c];
  if (group.empty && group.checked){
   html.push(createLabel(label,true));
   nl=true;
  }
 }
 if (nl) html.push(br);
 for (var i=1,labels;labels=genres[i];i++){
  var group=categories[i-1];
  if (group.checked){
   if (!group.image){
    for (c=0;label=labels[c];c++) html.push(createLabel(label));
   }else{
    for (c=0;label=labels[c];c++) html.push(createFlag(label));
   }
   if (c>0) html.push(br);
  }
 }
 var oCell=document.getElementById('oGroupName');
 oCell.innerHTML=html.join('');
 oCell.align='center';
}

function clearTable(row){
 var oList=document.getElementById('oMovieList');
 if (!row) {row=0; emptyTable=false;}
 while (oList.rows.length>row) oList.deleteRow(-1);
}
 
function showFavorites(){
 var l=movies[favorites].length;
 var csi='<center><strong>';
 var cso='</strong></center>';
 if (l>0){
  var csia=csi+'<a href="javascript:clearFavorites();" title="'+question+'">';
  var csoa='</a>'+cso;
 }else{
  var csia=csi;
  var csoa=cso;
 }
 document.getElementById('oGroupSel').innerHTML=csia+category.spaceIn()+csoa;
 document.getElementById('oPagesCount').innerHTML=csi+l+caption[l==1?7:8]+cso;
 if (sortkey!='') sort(sortkey);
 if (startfrom>=l && l>0) previousPage();
 showPage();
}

function showMovies(c){
 if (c) category=c;
 var l=movies[category].length;
 var csi='<center><strong>';
 var cso='</strong></center>';
 if (category==favorites && l>0){
  var csia=csi+'<a href="javascript:clearFavorites();" title="'+question+'">';
  var csoa='</a>'+cso;
 }else{
  var csia=csi;
  var csoa=cso;
 }
 document.getElementById('oGroupSel').innerHTML=csia+category.spaceIn()+csoa;
 document.getElementById('oPagesCount').innerHTML=csi+l+caption[l==1?7:8]+cso;
 if (sortkey!='') sort(sortkey);
 startfrom=0;
 showPage();
}

function showMovieDetails(e){
 e=getEventSource(e).more;
 for (var n=0,l=letters.length;n<=l;n++){
  var level=(n==0?'':letters.charAt(n-1));
  if (document.getElementById(e+level)) {toggle(e+level,-1);} else {break;}
 }
}

function showHideDetails(){
 if (!eval(my['expand'])) return;
 var l=movies[category].length;
 var finish=pagesize>0?(l-startfrom<pagesize?l:startfrom+pagesize):l;
 expanded=!expanded;
 for (var i=startfrom;i<finish;i++){
  var e=movies[category][i].getAttribute('Number').set();
  for (var n=0,l=letters.length;n<=l;n++){
   var level=(n==0?'':letters.charAt(n-1));
   if (document.getElementById(e+level)) {toggle(e+level,Number(expanded));} else {break;}
  }
 }
 footerBtn();
}
 
function showMoviePopup(e){
 var popup=document.getElementById('oPopup');
 var windowWidth=getWindowWidth();
 var windowHeight=getWindowHeight()-20;
 var x=mouseX(e)+16;
 var y=mouseY(e);
 popup.innerHTML='';
 popup.style.width=windowWidth*(mobilePhone()?0.90:0.72)+'px';
 popup.style.height='auto';
 e=getEventSource(e);
 var html=['<table class="boxbordercontent" cellspacing="0">'];
 html.push('<tr><td colspan="'+columns+'" class="bodycontent"><div class="boxcontent"><b>');
 html.push(e.innerHTML.replace(/<input[^>]+>/i,'')+'</b></div></td></tr>');
 for (var i=0,l=letters.length;i<=l;i++){
  var row=document.getElementById(e.more+(i==0?'':letters.charAt(i-1)));
  if (row) {html.push('<tr>'+row.innerHTML+'</tr>');} else {break;}
 }
 html.push('</table>');
 popup.innerHTML=html.join('');
 toggle('oPopup',1);
 var w=popup.offsetWidth;
 if (x+w>windowWidth) x=windowWidth-w-16;
 var h=popup.offsetHeight;
 if (mobilePhone()){
  y-=(h/2);
 }else{
  y-=document.getElementById('movies').offsetTop;
  if (y+h>windowHeight) y=windowHeight-h;
 }
 if (y<1) y=1;
 popup.style.position='fixed';
 popup.style.top=y+'px';
 popup.style.left=x+'px';
}

function hideMoviePopup(e){
 document.getElementById('oPopup').innerHTML='';
 toggle('oPopup',0);
}
 
function toggleMoviePopup(e){
 toggle('oPopup',-1);
}
 
function showPage(refresh){
 var oList=document.getElementById('oMovieList');
 var csi='<center><strong>';
 var cso='</strong></center>';
 var l=movies[category].length;
 var x=startfrom+(pagesize>0?pagesize:l)<l?startfrom+pagesize:l;
 var y=startfrom+1;
 if (l>0){
  showTitles(oList);
  oList=oList.rows[0];
  var oHead=document.getElementById('oHeaders').rows[0];
  for (var c=0;c<columns-1;c++){
   oHead.cells[c].style.width=oList.cells[c].offsetWidth-2+'px';
  }
 }else{
  noTitles(oList);
 }
 if (!refresh) {
  document.getElementById('movies').scrollTop='0';
  document.getElementById('oPagesInfo').innerHTML=csi+caption[5]+' '+currentPage()+caption[6]+totalPages()+cso;
  document.getElementById('oIndexInfo').innerHTML=csi+(l>0?y+(y!=x?'-'+x:''):sp)+cso;
  toolTipOff();
 }
}

function showTitles(oList){
 var z=0,html=[],shape=[],thumbnails=null;
 var newRow,oRow,oCell;
 if (emptyTable) clearTable();
 var finish=startfrom+pagesize;
 if (finish>movies[category].length || pagesize==0) finish=movies[category].length;
 for (var r=startfrom;r<finish;r++){
  rowindex=r+1;
  movie=movies[category][r];
  for (var i=0,nRow;nRow=xmlLayout.getElementsByTagName('row')[i];i++){
   if (!eval(nRow.getAttribute('thumbnails'))){
    if (z>=oList.rows.length){
     oRow=oList.insertRow(-1);
     newRow=true;
    }else{
     oRow=oList.rows[z];
     newRow=false;
    }
    z++;
    for (var n=0,att;att=nRow.attributes[n];n++){
     switch (att.name){
     case 'hide' : if (!expanded) {oRow.style.display='none';} break;
     case 'id'   : oRow.id=eval(att.value); break;
     case 'hover': addEvent(oRow,'mouseover',hoverOn,true);
                   addEvent(oRow,'mouseout',hoverOff,true); break;}
    }
    showCell(nRow,oRow,newRow,shape);
   }else{
    var nCell=nRow.getElementsByTagName('cell')[0];
    if (oList.rows.length==0){
     oRow=oList.insertRow(-1);
     oCell=oRow.insertCell(-1);
     oCell.className='bodycontent';
     for (var n=0,att;att=nCell.attributes[n];n++){
      switch (att.name){
      case 'colspan': oCell.colSpan=att.value; break;
      case 'align'  : oCell.align=att.value; break;
      case 'valign' : oCell.vAlign=att.value; break;}
     }
    }
    if (z==0) z=1;
    thumbnails=true;
    showImages(nCell,html,shape,eval(nRow.getAttribute('click')));
   }
  }
  if (separator){
   if (z>=oList.rows.length){
    oRow=oList.insertRow(-1);
    oCell=oRow.insertCell(0);
    oCell.colSpan=columns;
    oCell.className='bodycontent';
    oCell.innerHTML='<center><div class="boxcontent"></div></center>';
   }
   z++;
  }
 }
 if (thumbnails) oList.rows[0].cells[0].innerHTML=html.join('');
 for (var s in shape){
  var image=document.getElementById(s);
  switch (shape[s]){
  case 'film'  : cvi_strip.add(image); break;
  case 'reflex': cvi_reflex.add(image); break;}
 }
 clearTable(z);
}

function showCell(nRow,oRow,newRow,shape){
 var pin=nRow.getAttribute('pin')!=null;
 var popup=nRow.getAttribute('popup')!=null;
 var oCell;
 for (var i=0,nCell;nCell=nRow.getElementsByTagName('cell')[i];i++){
  if (newRow){
   oCell=oRow.insertCell(-1);
   oCell.className='bodycontent';
   for (var n=0,att;att=nCell.attributes[n];n++){
    switch (att.name){
    case 'width'  : oCell.style.width=att.value+'px'; break;
    case 'rowspan': oCell.rowSpan=att.value; break;
    case 'colspan': oCell.colSpan=att.value; break;
    case 'align'  : oCell.align=att.value; break;
    case 'valign' : oCell.vAlign=att.value; break;
    case 'style'  : oCell.id=att.value; break;
    case 'ident'  : oCell.className='bodyident'; break;}
   }
  }else{
   oCell=oRow.cells[i];
  }
  if (nCell.getAttribute('pin') || pin){
   oCell.more=eval((pin?nRow:nCell).getAttribute('pin'));
   addEvent(oCell,'click',showMovieDetails);
  }else if (nCell.getAttribute('popup') || popup){
   oCell.more=eval((popup?nRow:nCell).getAttribute('popup'));
   addEvent(oCell,'mouseover',showMoviePopup);
   addEvent(oCell,'mouseout',hideMoviePopup);
   addEvent(oCell,'click',toggleMoviePopup);
  }
  var html=[];
  for (var k=0,node;node=nCell.childNodes[k];k++){
   var select=null,playme=null;
   switch (node.nodeName){
   case 'text':
    var text=eval(node.firstChild.data);
    if (!text) break;
    var target='_blank',tip=null,url=null;
    for (var n=0,att;att=node.attributes[n];n++){
     switch (att.name){
     case 'style':
      for (var c=0,style;style=att.value.split(',')[c];c++){
       switch (style){
       case 'bold'     : text='<b>'+text+'</b>'; break;
       case 'italic'   : text='<i>'+text+'</i>'; break;
       case 'underline': text='<u>'+text+'</u>'; break;
       case 'justify'  : text='<p>'+text+'</p>'; break;
       default         : text='<'+style+'>'+text+'</'+style+'>';}
      }
      break;
     case 'url'   : url=eval(att.value); break;
     case 'target': target=att.value; break;
     case 'title' : tip=eval(att.value); break;}
    }
    if (url){
     if (!createURL(html,url,false)) html.push('<a href="',url,'" target="',target);
     if (tip) html.push('" title="',tip.encode());
     html.push('">',text.toString().linefeed(),'</a>');
    }else{
     html.push(text.toString().linefeed());
    }
    break;
   case 'play':
    playme=true;
   case 'img':
    select=true;
   case 'rate':
    var target='_blank',src=null,width=null,height=null,tip=null,url=null,style=null;
    for (var n=0,att;att=node.attributes[n];n++){
     switch (att.name){
     case 'src'   : src=select?eval(att.value):rate(att.value); break;
     case 'class' : if (view3D) {shape[src]=att.value; shape.length++;} break;
     case 'width' : width=att.value; break;
     case 'height': height=att.value; break;
     case 'url'   : url=eval(att.value); break;
     case 'target': target=att.value; break;
     case 'title' : tip=eval(att.value); break;
     case 'style' : style=att.value; break;}
    }
    if (!src) break;
    if (url){
     if (!createURL(html,url,true,playme)) html.push('<a href="',url,'" target="',target,'">');
    }else{
     if (playme) src=my['images']+my['stop'];
    }
    var image=['<img src=',src,' id=',src];
    if (width) image.push(' width=',width);
    if (height) image.push(' height=',height);
    if (style) image.push(' style=',style);
    if ((url||!select) && tip) image.push(' title=',tip.encode());
    image.push('>');
    html.push(image.join("'"));
    if (url) html.push('</a>');
    break;
   case 'flag':
    if (!select) select=1;
   case 'mpaa':
    if (!select) select=2;
   case 'region':
    if (!select) select=3;
   case 'video':
    if (!select) select=4;
   case 'audio':
    if (!select) select=5;
    var target='_blank',src=null,width=null,height=null,tip=null,url=null,flg=null,text=null,track=null,style=null,group=null,lf=null,styleIn='',styleOut='';
    for (var n=0,att;att=node.attributes[n];n++){
     switch (att.name){
     case 'src'   : src=eval(att.value); break;
     case 'class' : if (view3D) {shape[src]=att.value; shape.length++;} break;
     case 'width' : width=att.value; break;
     case 'height': height=att.value; break;
     case 'url'   : url=eval(att.value); break;
     case 'target': target=att.value; break;
     case 'title' : tip=eval(att.value); break;
     case 'flag'  : flg=eval(att.value); break;
     case 'text'  : text=eval(att.value); break;
     case 'track' : track=eval(att.value); break;
     case 'style' : style=att.value; break;
     case 'group' : group=eval(att.value); break;
     case 'lf'    : lf=eval(att.value); break;}
    }
    if (!src){
     if (select!=3) break;
     src=my['default_region']||'0';
    }
    var source=src.divide();
    group&=source.length>1;
    var id=track?track.divide():[''];
    if (style) {styleIn='<'+style+'>'; styleOut='</'+style+'>';}
    for (var n=0,img;img=source[n];n++){
     var file=setImg(select,img);
     if (file){
      var image=[];
      if (url) html.push('<a href="',url,'" target="',target,'">');
      image.push('<img src=',group?my['images']+(select==1?my['flag']:my['flag2']).replace('*','eu'):file);
      if (width) image.push(' width=',width);
      if (height) image.push(' height=',height);
      if (tip) image.push(' title=',select!=2?tip.encode():tip.joinTitle());
      image.push('> ');
      html.push(image.join("'"));
      if (track){
       var ifile=flag(id[n]||id[0],my['flag2']);
       if (flg && ifile){
        html.push('<img src="',group?my['images']+my['flag2'].replace('*','eu'):ifile,'"> ');
       }else{
        html.push(styleIn,(id[n]||id[0]),' ',styleOut);
       }
      }
      if (url) html.push('</a>');
      if (text) html.push(' ',styleIn,group?src:img,' ',styleOut);
      if (group) break;
     }else{
      if (track){
       var ifile=flag(id[n]||id[0]);
       if (flg && ifile){
        html.push('<img src="',group?my['images']+my['flag2'].replace('*','eu'):ifile,'"> ',styleIn);
       }else{
        html.push(styleIn,(id[n]||id[0]),' - ');
       }
      }else{
       html.push(styleIn);
      }
      html.push(img,styleOut);
     }
     if (lf) html.push(br);
    }
    break;
   case 'br':
    html.push(br); break;
   case 'sp':
    html.push(sp); break;
   case 'hr':
    html.push(hr); break;
   case 'box':
    var id=null,value='';
    for (var n=0,att;att=node.attributes[n];n++){
     switch (att.name){
     case 'pin'   : id=eval(att.value); break;
     case 'value' : value=eval(att.value); break;
     case 'save'  : if (save==null) save=eval(att.value); break;
     case 'totals': if (totals==null) totals=eval(att.value); break;}
    }
    if (id){
     html.push('<input type="checkbox"');
     html.push(' id=','B'+id);
     html.push(' value=',escape(value));
     if (movie.getAttribute('Bookmark')){
       html.push(' checked');
       if (!save) eraseCookie(id);
     }
     html.push(' onclick="bookmark('+id+')">');
    }
    break;}
  }
  oCell.innerHTML=html.join('');
 }
}

function setImg(select,img){
 switch (select){
 case 1: return flag(img);
 case 2: return mpaa(img);
 case 3: return region(img);
 case 4: return video(img);
 case 5: return audio(img);}
}

function showImages(nCell,html,shape,click){
 for (var i=0,node;node=nCell.childNodes[i];i++){
  switch (node.nodeName){
  case 'img':
   var target='_blank',image=[],url=null,style='';
   for (var n=0,att;att=node.attributes[n];n++){
    switch (att.name){
    case 'src'   : var src=eval(att.value); image.push('<img src=',src,' id=',src); break;
    case 'class' : if (view3D) {shape[src]=att.value; shape.length++;} break;
    case 'width' : image.push(' width=',att.value); break;
    case 'height': image.push(' height=',att.value); break;
    case 'style' : style=att.value; break;
    case 'url'   : url=eval(att.value); break;
    case 'target': target=att.value; break;
    case 'title' : image.push(click?' onclick=':' onmouseover=','toolTip(event,"'+eval(att.value)+'")'); break;}
   }
   image.push(' style=','margin:3px;'+style,'>');
   if (url){
    if (!createURL(html,url,true)) html.push('<a href="',url,'" target="',target,'">');
    html.push(image.join("'")+'</a>'+(shape.length>0?'':' '));
   }else{
    html.push(image.join("'")+(shape.length>0?'':' '));
   }
  }
 }
}

function createURL(html,url,closed,playme){
 var cmd=url.split(':',3);
 var pid=cmd[0]+':';
 if (pid!=scheme && !playme){
  return false;
 }
 var device=devices[player];
 var share=device['share'];
 var server=device['server'];
 var contents=(device['mime']||'').split(',');
 var mediaType=(movie.getAttribute('MediaType')||'').divide();
 var medium=mediaType[mediaType.length-1];
 if ((device['scan']||'').equalTo('first')) medium=mediaType[0];
 var id=new RegExp(medium,'i');
 var preset=true;
 switch (cmd.length){
 case 1:
  cmd.splice(0,0,device['protocol']);
  break;
 case 2:
  pid==scheme?cmd[0]=device['protocol']:preset=false;
  break;
 case 3:
  cmd.shift();
  preset=false;
 }
 switch ((player.isDune()?player.substr(0,4):player).toLowerCase()){
 case 'dune':
  home=device['dune'];
  var disk=device['none'];
  if (id.test(device['dvd'])) disk='dvd';
  if (id.test(device['bluray'])) disk='bluray';
  if (id.test(device['file'])) disk='file';
  if (preset){
   for (var c=0,content;content=contents[c];c++){
    var mime=content.split('/');
    if (id.test(mime[0])) {cmd[1]+='/'+mime[1]; break;}
   }
  }
  var nfs=cmd[0].equalTo('nfs')?':':'';
  var protocol=cmd[0]?cmd[0].replace(/local/,'storage_name')+':':'';
  server=server?'//'+(server+nfs).replace('::',':').addSlash():'';
  share=share?(share+nfs).replace('::',':').addSlash():'';
  var uri='http://'+home+'/cgi-bin/do?cmd=start_'+disk+'_playback&media_url='+protocol+((preset?server+share:'')+cmd[1]).replace(/\\/g,'/');
  html.push('<a href="javascript:invoke('+"'"+uri+"'"+')'+(closed?'">':''));
  return true;
 case 'pc':
  home=null;
  if (preset){
   if (id.test(device['dvd']) && !url.ext('iso')){
    cmd[1]+='/video_ts/video_ts.ifo';
   }else if (id.test(device['bluray']) && !url.ext('iso')){
    cmd[1]+='/bdmv/index.bdmv';
   }else{
    for (var c=0,content;content=contents[c];c++){
     var mime=content.split('/');
     if (id.test(mime[0])) {cmd[1]+='/'+mime[1]; break;}
    }
   }
  }
  if (device['ssh'] && document.URL.substr(7,3).equalTo('ssh')){
   server=device['ssh'];
  }else if (server.search(/local(host)?/)>=0){
   server=share.search(/^[a-z]:/i)>=0?'':'127.0.0.1';
  }else{
   home=server;
  }
  var protocol=cmd[0]?cmd[0].search(/^[a-z]$/i)>=0?cmd[0]+':':'':'';
  server=server?'//'+server.addSlash():'';
  share=share?share.addSlash():'';
  if (protocol.equalTo('http') || share.substr(0,5).equalTo('http:')){
   html.push('<a href="http:'+server+encodeURI(cmd[1].replace(/\\/g,'/'))+(closed?'">':''));
  }else{
   var uri=pcid+((preset?server+share:protocol)+cmd[1]).replace(/\\/g,'/');
   html.push('<a href="javascript:invoke('+"'"+uri+"'"+')'+(closed?'">':''));
  }
  return true;
 default:
  return false;
 }
}

function toggle3D(){
 view3D=!view3D;
 createCookie('layout.view3D',view3D,expiry);
 showPage(true);
}

function noTitles(oList){
 clearTable(0);
 var oCell=oList.insertRow(0).insertCell(0);
 oCell.align='center';
 oCell.className='bodycontent';
 oCell.colSpan=columns;
 oCell.style.color='red';
 oCell.innerHTML=caption[4];
 emptyTable=true;
}

function footerBtn(){
 document.getElementById('oExpand').innerHTML=buttons[Number(expanded)];
}

function firstPage(){
 startfrom=0;
 showPage();
}

function lastPage(){
 startfrom=movies[category].length-pagesize>0?movies[category].length-pagesize:0;
 showPage();
}

function nextPage(){
 startfrom+=startfrom+pagesize<movies[category].length?pagesize:0;
 showPage();
}

function previousPage(){
 startfrom=startfrom-pagesize>0?startfrom-pagesize:0;
 showPage();
}

function resizeBanner(){
 var height=document.getElementById('oMenu').offsetHeight;
 if (height<banner) height=banner;
 var top=invisible('oMenu')?banner:height;
 document.getElementById('header').style.top=top+'px';
 document.getElementById('banner').style.height=top+'px';
 document.getElementById('movies').style.top=top+document.getElementById('oMovieHeader').offsetHeight+'px';
}

function arrowTurn(){
 document.getElementById('oArrow').src=document.getElementById('oArrow').src.arrowRL(invisible('oExtra'));
}

function showSetup(forced){
 var menu=xmlLocale.getElementsByTagName('menu')[0];
 if (document.getElementById('oSetupLabel').innerHTML.indexOf('{TEXT}')>=0){
  var setupLabel=menu.getAttribute('setupLabel');
  var pageText=menu.getAttribute('pageText');
  document.getElementById('oSetupLabel').innerHTML=document.getElementById('oSetupLabel').innerHTML.replace('{TEXT}',setupLabel);
  document.getElementById('oPageText').innerHTML=document.getElementById('oPageText').innerHTML.replace('{TEXT}',pageText);
  document.getElementById('pageOK').value=document.getElementById('pageOK').value.replace('{OK}',OKButton);
  document.getElementById('defaults').value=document.getElementById('defaults').value.replace('{DEFAULT}',defaultButton);
 }
 var html=['<legend>'+caption[0]+'</legend>'];
 html.push('<input type="checkbox" name="view3D"'+(view3D?'checked':'')+' onclick="toggle3D()">3D'+br);
 for (var i=0,l=formats.length;i<l;i++){
  var format=layouts.replace('*',i+1);
  var procedure='setLayout("'+format+'");';
  html.push('<input type="radio" name="layouts"'+(layout==format?'checked':'')+' onclick='+procedure+'>'+formats[i]+br);
 }
 document.getElementById('oSetupLayouts').innerHTML=html.join('');
 document.getElementById('pagesize').value=pagesize;
 html=['<legend>'+caption[1]+'</legend>'];
 for (var n=0,c;c=categories[n];n++){
  html.push('<input type="checkbox" '+(c.checked?'checked':'')+' onclick=addCategory('+n+')>'+c.name+br);
 }
 document.getElementById('oSetupCategories').innerHTML=html.join('');
 var style=readCookie('layout.style')||getActiveStyleSheet();
 html=['<legend>'+caption[2]+'</legend>'];
 for (var k=0,a;a=document.getElementsByTagName('link')[k];k++){
  if (a.getAttribute('rel').indexOf('style')>=0){
   var name=a.getAttribute('title');
   if (name){
    var procedure='setActiveStyleSheet("'+name+'");';
    html.push('<input type="radio" name="styles"'+(name==style?'checked':'')+' onclick='+procedure+'>'+name+br);
   }
  }
 }
 document.getElementById('oSetupStyles').innerHTML=html.join('');
 html=['<legend>'+caption[3]+sp+'<a href="javascript:showExtra()"><img src="images/arrow-right.png" id="oArrow" width="11" height="11"></a></legend>'];
 for (var model in devices){
  var procedure='setPlayer("'+model+'");';
  html.push('<input type="radio" name="players"'+(model.equalTo(player)?'checked':'')+' onclick='+procedure+'>'+model+br);
 }
 document.getElementById('oPlayers').innerHTML=html.join('');
 toggle('oSetup',(forced?1:-1));
 if (invisible('oSetup')) toggle('oExtra',0);
 resizeBanner();
}

function showExtra(forced){
 document.getElementById('oExtraLabel').innerHTML=document.getElementById('oExtraLabel').innerHTML.replace('{TEXT}',caption[10]);
 var html=['<table cellspacing="0">'];
 var device=devices[player];
 for (var att in device){
  html.push('<tr><td width="60px" style="color:red">',sp+sp+att,'</td><td width="200px"><input type="text" id="'+att+'" size="35" value="'+device[att]+'"></td></tr>');
 }
 html.push('<tr><td colspan="2" align="center">');
 html.push('<input class="button" type="button" class="button" style="width:70px" value=" '+applyButton+' " onclick="javascript:setExtra(true);">'+sp+sp+sp);
 html.push('<input class="button" type="button" class="button" style="width:70px" value=" '+cancelButton+' " onclick="javascript:setExtra(false);">');
 html.push('</td></tr></table>');
 document.getElementById('oExtraText').innerHTML=html.join('');
 if (!forced) arrowTurn();
 toggle('oExtra',(forced?1:-1));
 resizeBanner();
}

function showInfo(){
 if (document.getElementById('oInfoLabel').innerHTML.indexOf('{TEXT}')>=0){
  var owner=xmlData.getElementsByTagName('Properties')[0].getAttribute('Owner')||'?';
  var update=xmlData.getElementsByTagName('AntMovieCatalog')[0].getAttribute('Date').replace(/ .+/,'')||'?';
  var titles=xmlData.getElementsByTagName('Movie').length||'?';
  var menu=xmlLocale.getElementsByTagName('menu')[0];
  var infoLabel=menu.getAttribute('infoLabel');
  var infoText=menu.getAttribute('infoText').mReplace({'\\|':br,'{OWNER}':owner,'{DATE}':update,'{TOTAL}':titles});
  document.getElementById('oInfoLabel').innerHTML=document.getElementById('oInfoLabel').innerHTML.replace('{TEXT}',infoLabel);
  document.getElementById('oInfoText').innerHTML=document.getElementById('oInfoText').innerHTML.replace('{TEXT}',infoText);
 }
 toggle('oInfo',-1);
 resizeBanner();
}

function showAbout(){
 if (document.getElementById('oAboutLabel').innerHTML.indexOf('{TEXT}')>=0){
  var menu=xmlLocale.getElementsByTagName('menu')[0];
  var aboutLabel=menu.getAttribute('aboutLabel');
  var aboutText=menu.getAttribute('aboutText').replace(/\|/g,br);
  document.getElementById('oAboutLabel').innerHTML=document.getElementById('oAboutLabel').innerHTML.replace('{TEXT}',aboutLabel);
  document.getElementById('oAboutText').innerHTML=document.getElementById('oAboutText').innerHTML.replace('{TEXT}',aboutText);
  document.getElementById('oAboutText').innerHTML+=br+'2011 &copy; Bergware International';
 }
 toggle('oAbout',-1);
 resizeBanner();
}

//CONTROL FUNCTIONS
function bookmark(id){
 for (var i=0,element;element=movies[all][i];i++){
  if (element.getAttribute('Number')==id) {var marked=element.getAttribute('Bookmark'); break;}
 }
 if (!marked){
  var value=document.getElementById('B'+id).value;
  element.setAttribute('Bookmark',value);
  if (save) createCookie(id,value,expiry);
  movies[favorites].push(element);
 }else{
  element.removeAttribute('Bookmark');
  if (save) eraseCookie(id);
  for (var n=0,list;list=movies[favorites][n];n++){
   if (list.getAttribute('Number')==id) {movies[favorites].splice(n,1); break;}
  }
 }
 if (category==favorites) {showFavorites();} else {onTop=true;}
}

function clearFavorites(){
 if (confirm(question.replace(/\|/g,'\n'))){
  for (var i=0,element;element=movies[all][i];i++){
   if (element.getAttribute('Bookmark')){
    element.removeAttribute('Bookmark');
    if (save) eraseCookie(element.getAttribute('Number'));
   }
  }
  movies[favorites]=[];
  showMovies();
 }
}

function invoke(content){
 if (!ip.network(home)){
  alert(outside);
  return;
 }
 if (content.substr(0,pcid.length)==pcid){
  var shell=new ActiveXObject('WScript.Shell');
  shell.run(devices[player]['application']+' "'+content.substr(pcid.length)+'"');
  return;
 }
 var xmlhttp=null;
 if (window.ActiveXObject){
  xmlhttp=new ActiveXObject('Microsoft.XMLHTTP');
 }else if (window.XMLHttpRequest){
  xmlhttp=new XMLHttpRequest();
 }
 if (xmlhttp){
  xmlhttp.open('GET',content,true);
  xmlhttp.onreadystatechange=function(){
   if (xmlhttp.readyState==4){}
  };
  xmlhttp.send(null);
 }else{
  alert("Your browser doesn't support XMLHTTP");
 }
}

function sendMail(){
 if (!oPopup.closed) oPopup.close();
 if (movies[favorites].length){
  oPopup=window.open('','','height=680,width=800,scrollbars=0,menubar=0,resizable=0,toolbar=0,location=0,directories=0,status=0');
  var form=oPopup.document;
  var required=[];
  var entries=(commentText?commentText.split('|'):[]);
  form.open('text/html','replace');
  form.write('<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">\n');
  form.write('<html><head><title>Mail Form</title></head><body>');
  if (action==mailto){
   form.write('<form enctype="text/plain" method="post" action="'+mailto+address+'?subject='+escape(subject)+'" accept-charset="UTF-8">');
  }else{
   form.write('<form enctype="multipart/form-data" method="post" action="'+action+'" accept-charset="UTF-8">');
   if (action.search(/mailform\.php$/i)>=0){
    for (var x=0,entry;entry=entries[x];x++) if (entry.search(/\*:?$/)>=0) required.push(entry.trim());
    if (required.length) form.write('<input type="hidden" name="required" value="'+required.join(',')+'">');
    form.write('<input type="hidden" name="recipient" value="'+address+'">');
    form.write('<input type="hidden" name="subject" value="'+subject+'">');
   }else if (action.search(/response-o-matic/i)>=0){
    var id=account.split(',');
    form.write('<input type="hidden" name="acctid" id="acctid" value="'+id[0]+'">');
    form.write('<input type="hidden" name="formid" id="formid" value="'+id[1]+'">');
   }
  }
  form.write('<B>'+favorites.spaceIn()+'</B>'+br+'<textarea name="1" id="titles" readonly rows="18" cols="95"></textarea>');
  var values=[];
  var disks=0,bytes=0;
  for (var i=0,element;element=movies[favorites][i];i++){
   values.push(element.getAttribute('Bookmark'));
   disks+=+element.getAttribute('Disks');
   bytes+=+element.getAttribute('Size');
  }
  form.getElementById('titles').value=unescape(values.sort(alphabetic).join('\n'));
  if (totals){
   var volume=[];
   if (totalTitles!='') volume.push(totalTitles+i);
   if (totalDisks!='') volume.push(totalDisks+disks);
   if (totalSize!='') volume.push(totalSize+bytes.grouped()+MB);
   var rows=volume.length;
   form.write('<textarea name="2" id="totals" readonly rows="'+rows+'" cols="95"></textarea>');
   form.getElementById('totals').value=unescape(volume.join('\n'));
  }
  form.write(br+br+'<B>'+comment+'</B>');
  if (commentText){
   form.write(hr+'<table border="0" cellspacing="2">');
   for (x=0;entry=entries[x];x++){
    form.write('<tr><td>'+entry+sp+sp+'</td><td><input type="text" size="30" name="'+entry+'"></td></tr>');
   }
   form.write('</table>'+hr+br);
  }else{
   form.write(br+'<textarea name="3" id="extra" rows="6" cols="95"></textarea>'+br+br);
  }
  form.write('<center><input type="submit" value="'+sendButton+'">'+sp+sp);
  form.write('<input type="button" value="'+closeButton+'" onClick="self.close()">');
  form.write('</center></form></body></html>');
  form.close();
  oPopup.focus();
 }else{
  alert(warning.join('\n').replace('{NAME}',favorites.spaceIn()));
 }
}

function sortMovies(e){
 e=getEventSource(e);
 if (e.sort==sortkey){
  sortdir=!sortdir;
  createCookie(cookie('sortdir'),sortdir,expiry);
  e.innerHTML=e.innerHTML.arrowSwap();
 }else{
  if (sortkey!='' && column) column.innerHTML=column.innerHTML.arrowOff();
  sortdir=false;
  createCookie(cookie('sortkey'),e.sort,expiry);
  eraseCookie(cookie('sortdir'));
  e.innerHTML=e.innerHTML.arrowOn();
  column=e;
 }
 sort(e.sort);
 showPage();
}

function sortList(){
 var e=document.getElementById('oSortList').value;
 createCookie(cookie('sortkey'),e,expiry);
 sortdir=false;
 sort(e);
 showPage();
}

function sort(k){
 sortkey=k;
 sortfield=(k!='Date'?k:dateYMD);
 var l=k.length;
 if ((l>5?k.substr(l-5,5):k)=='Title') {
  movies[category]=movies[category].sort(movieTitle);
 }else{
  movies[category]=movies[category].sort(custom);
 }
}

function alphabetic(x,y){
 if (x>y) return 1;
 if (x<y) return -1;
 return 0;
}

function custom(x,y){
 var a=fix(x.getAttribute(sortfield));
 var b=fix(y.getAttribute(sortfield));
 if (a>b) return sortdir?-1:1;
 if (a<b) return sortdir?1:-1;
 return 0;
}

function movieTitle(x,y){
 var a=lowerCase(x.getAttribute(sortfield));
 var b=lowerCase(y.getAttribute(sortfield));
 if (a>b) return sortdir?-1:1;
 if (a<b) return sortdir?1:-1;
 return 0;
}

function setPagesize(){
 pagesize=Math.floor(document.getElementById('pagesize').value);
 createCookie(cookie('pagesize'),pagesize,expiry);
 toggle('oSetup',0);
 toggle('oExtra',0);
 resizeBanner();
 showPage();
}

function soundex(text){
 if (!text) return '';
 if (!isNaN(text)) return text;
 var r,s,p=[];
 var m={BFPV:1,CGJKQSXZ:2,DT:3,L:4,MN:5,R:6};
 for (var c=0,word;word=text.toUpperCase().split(' ')[c];c++){
  r=(s=word.replace(/[^A-Z]/g,'').split('')).splice(0,1);
  for (var i=0;i<s.length;i++)
   for (var j in m)
    if (j.indexOf(s[i])+1 && r[r.length-1]!=m[j] && r.push(m[j])) break;
  p.push(r.join(''));
 }
 return p.join('');
}

function search(){
 var text=document.getElementById('oFindText').value;
 if (!text) return;
 var select=[0,1,0,0,0,0,0,0,0,0,0,1,0,1,0,1,0,0,0,0,1,1,0,0,0,0,1,1,0,0,0,0];
 var scope=(document.getElementById('oScope').checked?category:all);
 if (scope==find){
  scope='_TMP_';
  movies[scope]=movies[find];
 }
 movies[find]=[];
 text=text.trim().replace(/\s+/g,' ');
 var area=document.getElementById('oField').value;
 var areas=(area=='all'?searchkey:area).split(',');
 var pattern1=new RegExp(text,'i');
 var pattern2=new RegExp(soundex(text));
 var phonetic=[];
 for (var a=0;area=areas[a];a++){
  for (var f=1,field;field=xmlLocale.getElementsByTagName('field')[0].attributes[f];f++){
   if (area==field.name) {phonetic.push(select[f]); break;}
  }
 }
 for (var i=0,element;element=movies[scope][i];i++){
  for (var n=0;area=areas[n];n++){
   if (phonetic[n]==0){
    if (pattern1.test(element.getAttribute(area))){
     movies[find].push(element);
     break;
    }
   }else{
    if (pattern2.test(soundex(element.getAttribute(area)))){
     movies[find].push(element);
     break;
    }
   }
  }
 }
 showMovies(find);
}

function setExtra(apply){
 if (apply){
  var device=devices[player];
  for (var att in device) device[att]=document.getElementById(att).value;
 }
 arrowTurn();
 toggle('oExtra',0);
 resizeBanner();
 showPage(true);
}

function setPlayer(model){
 player=model;
 createCookie('player',player,expiry);
 if (!model.isDune() && !oPopup.closed) oPopup.close();
 if (!invisible('oExtra')) showExtra(true);
 showPage(true);
}

function remoteControl(){
 if (!player.isDune()) return;
 if (oPopup.closed){
  oPopup=window.open('duneRemote.html',home.replace(/\./g,'p'),'height=750,width=236,scrollbars=0,menubar=0,resizable=0,toolbar=0,directories=0,status=0');
  oPopup.moveTo((getWindowWidth()-236)/2,60);
  oPopup.focus();
 }else{
  oPopup.close();
 }
}

function sum(input,output,l){
 if (!input) return;
 var range=output;
 if (!l) l=1;
 for (var n=0,item;item=input.divide()[n];n++){
  var x=item.indexOf(' - ');
  if (x!=-1) item=item.substr(0,x);
  if (!range[item]) {range[item]=l; range.length++;} else {range[item]+=l;}
 }
}

function rank(list,group){
 var level=group;
 var top=level.length;
 var count=new Array(top);
 for (var t=0;t<top;t++) count[t]=0;
 for (var x in list){
  for (t=0;t<top;t++){
   if (list[x]>count[t]){
    level.splice(t,0,x);
    count.splice(t,0,list[x]);
    level.splice(top,1);
    count.splice(top,1);
    break;
   }
  }
 }
}

function leapDays(startdate,enddate){
 var year1=startdate.getFullYear();
 var year2=enddate.getFullYear();
 var march=new Date(year1,2,1);
 var count=0;
 for (var y=year1;y<year2;y++){
  if (y==year1 && startdate>=march) continue;
  if (((y%4==0)&&(y%100!=0))||(y%400==0)) count++;
 }
 return count;
}

function display(length,leapdays){
 var d=Math.floor(length/1440)-leapdays;
 var y=Math.floor(d/365);
 d-=y*365;
 var w=Math.floor(d/7);
 d-=w*7;
 var text=[];
 if (y>0) text.push(y+' '+(y==1?year:years));
 if (w>0) text.push(w+' '+(w==1?week:weeks));
 if (d>0) text.push(d+' '+(d==1?day:days));
 length%=1440;
 if (length>0){
  var h=Math.floor(length/60);
  var m=length-h*60;
  text.push(h+':'+(m<10?'0':'')+m+' '+hour);
 }
 return text.join(', ');
}

function moreInfo(){
 var info=document.getElementById('oMore'),item;
 if (info.style.visibility=='visible'){
  info.style.visibility='hidden';
 }else{
  var top=+my['top']||3,disks=0,length=0,first=0,last=0;
  var actor=new Array(top),director=new Array(top),country=new Array(top);
  var sources=[],sources2=[],cast=[],crew=[],world=[];
  var actors=[],directors=[],countries=[];
  for (var i=0,element;element=movies[category][i];i++){
   disks+=+element.getAttribute('Disks');
   length+=+element.getAttribute('Length');
   sum(element.getAttribute('Source'),sources);
   sum(element.getAttribute('Source'),sources2,+element.getAttribute('Disks'));
   sum(element.getAttribute('Actors'),cast);
   sum(element.getAttribute('Director'),crew);
   sum(element.getAttribute('Country'),world);
   var dt=ymd(element.getAttribute('Date'));
   if (dt>0){
    var date=new Date(Math.floor(dt/10000),Math.floor((dt%10000)/100),dt%100);
    if (date<first||first==0) first=date;
    if (date>last) last=date;
   }
  }
  rank(cast,actor);
  rank(crew,director);
  rank(world,country);
  for (t=0;t<top;t++){
   i=actor[t]; if (i) actors.push(i+(cast[i]>1?' '+cast[i]+'x':''));
   i=director[t]; if (i) directors.push(i+(crew[i]>1?' '+crew[i]+'x':''));
   i=country[t]; if (i) countries.push(i+(world[i]>1?' '+world[i]+'x':''));
  }
  var age=Math.ceil((last-first)/(1440*60000))*1440;
  var column1='<tr><td align="right" class="nw"><b>';
  var column2=':'+sp+'</b></td><td class="nw"><i>';
  var columnE='</i></td></tr>';
  var html=['<table cellspacing="0">'];
  var a1=cast.length, a2=actors.length;
  var b1=crew.length, b2=directors.length;
  var c1=world.length,c2=countries.length;
  html.push(column1+summary[0]+column2+movies[category].length);
  for (var s in sources) html.push(' ['+s+' '+sources[s]+']');
  html.push(columnE);
  html.push(column1+summary[1]+column2+disks);
  for (var s in sources2) html.push(' ['+s+' '+sources2[s]+']');
  html.push(columnE);
  html.push(column1+summary[2]+column2+display(length,0)+columnE);
  html.push(column1+summary[3]+column2+(age>0?display(age,leapDays(first,last)):'0 '+days)+columnE);
  html.push('<tr><td colspan="2" class="nw">'+hr+'</td></tr>');
  html.push(column1+summary[4]+column2+a1+' ('+(a1>a2?summary[7]+a2+': ':'')+actors.join(', ')+')'+columnE);
  html.push(column1+summary[5]+column2+b1+' ('+(b1>b2?summary[7]+b2+': ':'')+directors.join(', ')+')'+columnE);
  html.push(column1+summary[6]+column2+c1+' ('+(c1>c2?summary[7]+c2+': ':'')+countries.join(', ')+')'+columnE);
  html.push('</table>');
  info.innerHTML=html.join('');
  var x=getWindowWidth()-info.offsetWidth-16;
  var y=(mobilePhone()?document.getElementById('footer').offsetTop:getWindowHeight())-info.offsetHeight-20;
  info.style.position='fixed';
  info.style.left=x+'px';
  info.style.top=y+'px';
  info.style.visibility='visible';
 }
}
function toolTip(e,img){
 var tip=document.getElementById('oTip');
 var windowWidth=getWindowWidth();
 var windowHeight=getWindowHeight()-20;
 var html=['<table cellpadding="0" cellspacing="0">'];
 for (var n=0,l=letters.length;n<=l;n++){
  var row=document.getElementById(img+(n==0?'':letters.charAt(n-1)));
  if (row) {html.push('<tr>'+row.innerHTML+'</tr>');} else {break;}
 }
 html.push('</table>');
 tip.style.width=windowWidth*(mobilePhone()?0.90:0.72)+'px';
 tip.style.height='auto';
 tip.innerHTML=html.join('');
 var w=tip.offsetWidth;
 var x=mouseX(e)-(w/4);
 if (x<2){
  x=2;
 }else if (x+w>windowWidth){
  x=windowWidth-w-16;
 }
 var y=mouseY(e);
 var h=tip.offsetHeight;
 if (mobilePhone()){
  y-=(h/2);
  if (y>windowHeight) y=windowHeight-(h/2)+20;
 }else{
  y+=20;
  if (y+h>windowHeight) y-=(h+30);
 }
 if (y<1) y=1;
 tip.style.position='fixed';
 tip.style.top=y+'px';
 tip.style.left=x+'px';
 tip.style.visibility='visible';
 addEvent(tip,'click',toolTipOff,true);
}

function toolTipOff(){
 if (onTop){
  setTimeout('showPage(true)',0);
  onTop=null;
 }else{
  document.getElementById('oTip').style.visibility='hidden';
 }
}